program p

use io
use kahan_sum

implicit none
include "fftw3.f"
include "mpif.h"
!ifort  p.f90 -I /opt/intel/mkl/include/fftw -L /opt/intel/mkl/lib/em64t/ -lfftw3xf_intel -lmkl_intel_ilp64 -lmkl_intel_thread -lmkl_core -liomp5 -lpthread

type(cube)               :: c
type(cube)               :: vh
integer                  :: i,j,k,ig,jg,l,m,n,iunit,vi(3),iplane,nstates,neig,ifirst
integer                  :: nxy,ntouse,nz,nx,ny,myid,numprocs,ierr
integer                  :: lname1, lname2,istates,ikmax
integer                  :: iy(2)
real*8, allocatable      :: eig(:),rho(:,:,:),gvecs(:,:,:),rvecs(:,:,:),ngvecs(:,:),allorig(:,:),allnew(:,:),sums(:,:),rhonow(:,:,:)
real*8, allocatable      :: rhotmp(:,:,:)
real*8                   :: rho1,rho2,rho3,vbias,zsafe,vref,Vthr,eigref,hartree,norma,val1,val2
real*8                   :: theeig
real*8                   :: r,vr(3),sum,gvec(2),rxy(2),znow,dx(3,3),dzpar,vh1(3),vh2(3),gd(2,2),area
complex*16,allocatable   :: arr(:,:),arro(:,:),crho(:,:,:)
complex*16               :: zeval2
real*8                   :: val,err,scal,zplane,zmax,lx,ly
integer*8                :: plan
character(len=50)        :: fi,fh,fo
character(len=12)        :: scn
character(len=12)        :: fmts
character(len=80)        :: line
logical                  :: reached

call MPI_INIT(ierr)
call MPI_COMM_RANK(MPI_COMM_WORLD, myid, ierr)
call MPI_COMM_SIZE(MPI_COMM_WORLD, numprocs, ierr)


pi=4.d0*datan(1.d0)
hartree=13.605*2.d0
zsafe=2.d0/0.529177
fi=""
fo=""
fh=""
fmts="(     e20.8)"

if(myid.eq.0) then

print*,"name cp2k output"
read(5,45)fi
scn="Project name"
print*,"Vbias and threshold for degeneracy of eigenvalues"
read(5,*)vbias,Vthr
print*,"name hartree.cube"
read(5,45)fh
print*,"nome cube file output"
read(5,45)fo


iunit=13

!!!!!!!!!!!!!!!!! VACUUM POTENTIAL !!!!!!!!!!!!!!!!!

open(unit=iunit,file=fh,status="unknown")
 call read_cube(vh,iunit)
close(unit=iunit)
vr=0
nxy=vh%nx*vh%ny
nz=vh%nz
ny=vh%ny
nx=vh%nx
dx=vh%dx
print*,dx(1,1:3)
print*,dx(2,1:3)
print*,dx(3,1:3)
if(abs(dx(1,2))+abs(dx(1,3))+abs(dx(3,1))+abs(dx(3,2)).gt.0.001)then
 print*," too difficult"
 stop
endif

vr(3)=maxval(vh%pos(:,3))
vr(3)=vr(3)+zsafe
call ijk(vi,vr,vh%dx)
call xyz(vi,vr,vh%dx)
vref=accurate_sum(vh%rho(1:vh%nx,1:vh%ny,vi(3)))/nxy
print*," vref is ",vref 

dzpar=dx(3,3)*dsin( ang(dx(3,1:3),dx(2,1:3))/180.d0*pi )

iplane=vi(3)
zplane=(iplane-1)*dzpar   
print*," zplane and iplane are: ",zplane,iplane
print*," give me zmax"
read*,zmax
vr=0
vr(3)=zmax
call ijk(vi,vr,vh%dx)
ikmax=vi(3)
call free_cube(vh)
endif !! first serial section

call mpi_bcast(nxy, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(nx, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(ny, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(nz, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(dx, 9, mpi_double_precision, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(vref, 1, mpi_double_precision, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(dzpar, 1, mpi_double_precision, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(zplane, 1, mpi_double_precision, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(iplane, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(ikmax, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)

!call mpi_barrier(MPI_COMM_WORLD,ierr)


!!!!!!!!!!!!!!!!! END VACUUM POTENTIAL !!!!!!!!!!!!!!!!!

call intervals(ny,numprocs,myid,iy(1),iy(2))
print*,"myid ",myid,iy(1),iy(2)

allocate(rho(nx,ny,nz))
allocate(rhonow(nx,ny,nz))
allocate(rhotmp(nx,ny,nz))
l=nx
m=ny
allocate(arr(l,m))
allocate(arro(l,m))

vh1=0.d0
vh2=0.d0
vh1(1:2)=dx(1,1:2)*nx
vh2(1)=dx(2,1)*ny
vh2(2)=dsqrt( dx(2,2)**2 + dx(2,3)**2 )*ny
call vecprod(vh1,vh2)
vh2=0.d0
vh2(3)=1.d0
area=scalar(vh1,vh2)
if(myid.eq.0) print*,"area ",area
vh1=0.d0
vh1(1)=dx(2,1)*ny
vh1(2)=dsqrt( dx(2,2)**2 + dx(2,3)**2 )*ny
call vecprod(vh1,vh2)
gd(1,1:2)=2*pi*vh1(1:2)/area

vh1=vh2
vh2(1:2)=dx(1,1:2)*nx
vh2(3)=0.d0
call vecprod(vh1,vh2)
gd(2,1:2)=2*pi*vh1(1:2)/area

!!!!!!!!!!!!!!!! DEFINE RANGE of eigenvalues !!!!!!!!!!!

if(myid.eq.0) then

open(unit=iunit,file=fi,status="unknown")
do while(.not.thereis(line,scn))
 read(iunit,33,END=37)line
enddo
ifirst=first_char(line(22:80))
call read_cp2k_eig(eig,iunit)
close(unit=iunit)

neig=size(eig(:))

print*,"total number of filled states:",neig

lname1=80-21-ifirst+1
lname2=5  !ndigits(neig)
fi(1:lname1)=line(21+ifirst:80)
fi(lname1+1:lname1+5 )="-WFN_"
do i=1,lname2
 fi(lname1+5+i:lname1+5+i)="0"
enddo

fi(lname1+5+lname2+1:lname1+5+lname2+11)="_1-1_0.cube"

print*,fi

ntouse=0
eigref=eig(neig)
reached=.false.
i=neig
do while(.not.reached)
 if((-eig(i)+eig(neig))*hartree .gt. abs(vbias)) then
    reached=.true.
 else
    eigref =eig(i)
    i=i-1
    ntouse=ntouse+1
 endif
enddo

reached=.false.
i=i-1
do while(.not.reached)
 if( (-eig(i)+eigref)*hartree .gt. Vthr) then 
  reached=.true.
 else
  eigref=eig(i)
  i=i-1
  ntouse=ntouse+1
 endif
enddo

print*,"I will use ",ntouse," states"

endif !! second scalar section

call mpi_bcast(ntouse, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
call mpi_bcast(neig, 1, mpi_integer, 0, MPI_COMM_WORLD, ierr)
!call mpi_barrier(MPI_COMM_WORLD,ierr)
if(myid.gt.0)allocate(eig(neig))
call mpi_bcast(eig, neig, mpi_double_precision, 0, MPI_COMM_WORLD, ierr)
call mpi_barrier(MPI_COMM_WORLD,ierr)


!!!!!!!!!!!!!END DEFINE RANGE of eigenvalues !!!!!!!!!!!


allocate(allorig(nz,ntouse+1))
allocate(allnew(nz,ntouse+1))
allocate(sums(nz,ntouse+1))
allocate(crho(nx,ny,nz))

allorig=0
allnew=0
if(myid.eq.0)then
do i=1,ikmax !vh%nz
 allorig(i,1)=(i-1)*dx(3,3)
 allnew(i,1)=(i-1)*dx(3,3)
enddo
endif

fmts(6-ndigits(ntouse+1)+1:6)=ntouse+1

rho=0.d0
lx=nx*dx(1,1)
ly=ny*dx(2,2)
scal=1.d0/nxy

if(myid.eq.0)print*,"iplane ande ikmax ",iplane,ikmax

do istates=neig,neig-ntouse+1,-1   !!!!!!!! MAIN DO

if(myid.eq.0)print*, "doing state ",istates

theeig=eig(istates)-vref

rhotmp=0.d0
rhonow=0.d0
crho=0.d0


if(myid.eq.0) then    !!!!1 serial
do i=1,lname2
 fi(lname1+5+i:lname1+5+i)="0"
enddo
fi(lname1+5+lname2-ndigits(istates)+1:lname1+5+lname2)=istates

print*,"reading file ",fi(1:lname1+5+lname2+11)


!!!!!!!!!!!!!!!!!!!!!!!!   READ NEW STATE !!!!!!!!!!!!!!!!!!!!!!!!1111
open(unit=iunit,file=fi,status="unknown")
 call read_cube(c,iunit)
close(unit=iunit)

rhonow=c%rho

endif !!! processor 0 reads state

call mpi_barrier(MPI_COMM_WORLD,ierr)
call mpi_bcast(rhonow, nx*ny*nz, mpi_double_precision, 0, MPI_COMM_WORLD, ierr)
!call mpi_barrier(MPI_COMM_WORLD,ierr)

!!!!!!!!!!!!!!!!!!!!!END   READ NEW STATE !!!!!!!!!!!!!!!!!!!!!!!!1111

do i=1,ikmax !c%nz
 allorig(i,neig-istates+2)=accurate_sum(rhonow(1:nx,iy(1):iy(2),i)**2)/nxy
enddo
allnew(1:iplane,neig-istates+2)=allorig(1:iplane,neig-istates+2)

if(myid.eq.0) then
sum=accurate_sum(rhonow*rhonow)
print*,"cube file norm: ",sum*c%dv
endif

arr=rhonow(1:nx,1:ny,iplane)

CALL DFFTW_PLAN_DFT_2D(PLAN, l,m, arr, arro, FFTW_FORWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)


    do jg=1,ny
   if( (mod(jg,10).eq.0) .and. myid.eq.0 ) write(6,*)nint(jg*1.d0/ny*100.d0)," % done"
   do ig=1,nx

       if(ig.gt.nx/2+1 .and. jg.gt.ny/2+1 ) then
       gvec(1)=gd(1,1)*(ig-nx-1) + gd(2,1)*(jg-ny-1)
       gvec(2)=gd(1,2)*(ig-nx-1) + gd(2,2)*(jg-ny-1)
       else if(ig.gt.nx/2+1) then
       gvec(1)=gd(1,1)*(ig-nx-1) + gd(2,1)*(jg-1)
       gvec(2)=gd(1,2)*(ig-nx-1) + gd(2,2)*(jg-1)
       else if(jg.gt.ny/2+1) then
       gvec(1)=gd(1,1)*(ig-1) + gd(2,1)*(jg-ny-1)
       gvec(2)=gd(1,2)*(ig-1) + gd(2,2)*(jg-ny-1)
       else
       gvec(1)=gd(1,1)*(ig-1) + gd(2,1)*(jg-1)
       gvec(2)=gd(1,2)*(ig-1) + gd(2,2)*(jg-1)
       endif

  do k=    iplane+1, nz
     znow=(k-1)*dzpar
      val1=dexp(-1.d0*dsqrt(-2*theeig + gvec(1)*gvec(1)+gvec(2)*gvec(2))*(znow-zplane))

 do j=iy(1),iy(2)

   rxy(2)=(j-1) * dsqrt((dx(2,2))**2 + (dx(2,3))**2) 
do i=1,nx  !,c%nx
   rxy(1)=(j-1) * dx(2,1)
   rxy(1)=rxy(1)+(i-1) * dx(1,1)




      val2=gvec(1)*rxy(1) + gvec(2)*rxy(2)
      crho(i,j,k)=crho(i,j,k)+scal*arro(ig,jg)*val1*zexp(dcmplx(0.d0,1.d0)*val2)

  enddo
 enddo
enddo

    enddo
   enddo

rho(1:nx,iy(1):iy(2),1:iplane)       = rho(1:nx,iy(1):iy(2),1:iplane)+rhonow(1:nx,iy(1):iy(2),1:iplane)**2
rhotmp(1:nx,iy(1):iy(2),iplane+1:ikmax) = &
        real( crho(1:nx,iy(1):iy(2),iplane+1:ikmax) * conjg ( crho(1:nx,iy(1):iy(2),iplane+1:ikmax) ) )
rho(1:nx,iy(1):iy(2),iplane+1:ikmax) = rho(1:nx,iy(1):iy(2),iplane+1:ikmax) + rhotmp(1:nx,iy(1):iy(2),iplane+1:ikmax)

do i=iplane+1, ikmax 
 allnew(i,neig-istates+2)=accurate_sum(rhotmp(1:nx,iy(1):iy(2),i))/nxy
enddo

enddo  !!!!!!!! END MAIN DO


!do i=1,nx  !!!!!!!1debug
! do j=1,ny  !!!!!!!1debug
!
!      write(44,66)i,j,rhonow(i,j,iplane),crho(i,j,iplane)  !!!!!!!1debug
!enddo  !!!!!!!1debug
!enddo  !!!!!!!1debug
!stop  !!!!!!!1debug

rhonow=0.d0
call mpi_barrier(MPI_COMM_WORLD,ierr)
call mpi_reduce(rho,rhonow,nx*ny*nz,mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)

!call mpi_barrier(MPI_COMM_WORLD,ierr)

if(myid.eq.0) then !! last serial section
open(unit=iunit,file=fo,status="unknown")
c%rho=rhonow
call write_cube(c,iunit)
close(unit=iunit)
endif

sums=0
!call mpi_barrier(MPI_COMM_WORLD,ierr)
call mpi_reduce(allorig,sums,nz*(ntouse+1),mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
!call mpi_barrier(MPI_COMM_WORLD,ierr)

if(myid.eq.0) then !! last serial section
open(unit=iunit,file="leorig",status="unknown")
 do i=1, ikmax 
  write(iunit,fmts)sums(i,1:ntouse+1)
 enddo
close(unit=iunit)
endif

sums=0
!call mpi_barrier(MPI_COMM_WORLD,ierr)
call mpi_reduce(allnew,sums,nz*(ntouse+1),mpi_double_precision,mpi_sum,0,mpi_comm_world,ierr)
!call mpi_barrier(MPI_COMM_WORLD,ierr)
if(myid.eq.0) then !! last serial section
open(unit=iunit,file="lenew",status="unknown")
 do i=1,ikmax
  write(iunit,fmts)sums(i,1:ntouse+1)
 enddo
close(unit=iunit)

open(unit=iunit,file="latotal",status="unknown")
 do i=1,ikmax
  write(iunit,38)allnew(i,1),accurate_sum(c%rho(1:nx,1:ny,i))/nxy
 enddo
close(unit=iunit)

call free_cube(c)

endif  !! last serial section

call mpi_barrier(MPI_COMM_WORLD,ierr)
deallocate(rho)
deallocate(rhotmp)
deallocate(arr)
deallocate(arro)
deallocate(allorig)
deallocate(allnew)
deallocate(crho)
deallocate(eig)
deallocate(sums)

30 format(4e20.8)
33 format(a80)
45 format(a)
34 format(f12.6,3e20.8)
36 format(2i4,3e20.8)
38 format(2e20.8)
37 continue
51 format(3i4,4e20.8)
66 format(2i4,3e20.8)
433 format(3i4,3e20.8)
445 format(2e20.8)


end
