program p

use io
use kahan_sum

implicit none
include "fftw3.f"
!ifort  p.f90 -I /opt/intel/mkl/include/fftw -L /opt/intel/mkl/lib/em64t/ -lfftw3xf_intel -lmkl_intel_ilp64 -lmkl_intel_thread -lmkl_core -liomp5 -lpthread

type(cube)               :: c
type(cube)               :: vh
integer                  :: i,j,k,ig,jg,l,m,n,iunit,vi(3),iplane,nstates,neig,ifirst
integer                  :: nxy,ntouse,nz,nx,ny
integer                  :: lname1, lname2,istates,ikmax
real*8, allocatable      :: eig(:),rho(:,:,:),gvecs(:,:,:),rvecs(:,:,:),ngvecs(:,:),allorig(:,:),allnew(:,:)
real*8, allocatable      :: rhotmp(:,:,:)
real*8                   :: rho1,rho2,rho3,vbias,zsafe,vref,Vthr,eigref,hartree,norma,val1,val2
real*8                   :: dx,dy,dz,theeig
real*8                   :: r,vr(3),sum,gvec(2),rxy(2),znow
complex*16,allocatable   :: arr(:,:),arro(:,:),crho(:,:,:)
complex*16               :: zeval2
real*8                   :: val,err,scal,zplane,zmax,lx,ly
integer*8                :: plan
character(len=50)        :: fi,fh,fo
character(len=12)        :: scn
character(len=12)        :: fmts
character(len=80)        :: line
logical                  :: reached

pi=4.d0*datan(1.d0)
hartree=13.605*2.d0
zsafe=3.d0/0.529177
fi=""
fo=""
fh=""
fmts="(     e20.8)"

print*,"name cp2k output"
read(5,45)fi
scn="Project name"
print*,"Vbias and threshold for degeneracy of eigenvalues"
read(5,*)vbias,Vthr
print*,"name hartree.cube"
read(5,45)fh
print*,"nome cube file output"
read(5,45)fo


iunit=13

!!!!!!!!!!!!!!!!! VACUUM POTENTIAL !!!!!!!!!!!!!!!!!

open(unit=iunit,file=fh,status="unknown")
 call read_cube(vh,iunit)
close(unit=iunit)
vr=0
nxy=vh%nx*vh%ny
nz=vh%nz
ny=vh%ny
nx=vh%nx

vr(3)=maxval(vh%pos(:,3))
print*,vr
vr(3)=vr(3)+zsafe
call ijk(vi,vr,vh%dx)
call xyz(vi,vr,vh%dx)
vref=accurate_sum(vh%rho(1:vh%nx,1:vh%ny,vi(3)))/nxy
print*," vref at z ",vr(3)," is ",vref 


iplane=vi(3)
zplane=vr(3)
print*," zplane is: ",zplane,iplane
print*," give me zmax"
read*,zmax
vr=0
vr(3)=zmax
call ijk(vi,vr,vh%dx)
ikmax=vi(3)


!!!!!!!!!!!!!!!!! END VACUUM POTENTIAL !!!!!!!!!!!!!!!!!

allocate(rho(vh%nx,vh%ny,vh%nz))
allocate(rhotmp(vh%nx,vh%ny,vh%nz))
l=vh%nx
m=vh%ny
allocate(arr(l,m))
allocate(arro(l,m))
rho=0.d0
rhotmp=0.d0



!!!!!!!!!!!!!!!! DEFINE G vectors and exponentials  !!!

allocate(gvecs(vh%nx,vh%ny,2))
allocate(ngvecs(vh%nx,vh%ny))
allocate(rvecs(vh%nx,vh%ny,2))

do i=1,c%nx
 do j=1,c%ny
   rvecs(i,j,1)=(i-1) * c%dx(1,1)
   rvecs(i,j,2)=(j-1) * c%dx(2,2)
 enddo
enddo

do ig=1,c%nx
 do jg=1,c%ny
   gvecs(ig,jg,1)=2*pi/lx*(ig-1)
   if(ig.gt.c%nx/2+1)gvecs(ig,jg,1)=2*pi/lx*(ig-c%nx-1)
   gvecs(ig,jg,2)=2*pi/ly*(jg-1)
   if(jg.gt.c%ny/2+1)gvecs(ig,jg,2)=2*pi/ly*(jg-c%ny-1)
   ngvecs(ig,jg)=gvecs(ig,jg,1)*gvecs(ig,jg,1) + gvecs(ig,jg,2)*gvecs(ig,jg,2)
 enddo
enddo

!!!!!!!!!!!!!END DEFINE G vectors and exponentials  !!!


!!!!!!!!!!!!!!!! DEFINE RANGE of eigenvalues !!!!!!!!!!!

open(unit=iunit,file=fi,status="unknown")
do while(.not.thereis(line,scn))
 read(iunit,33,END=37)line
enddo
ifirst=first_char(line(22:80))
call read_cp2k_eig(eig,iunit)
close(unit=iunit)

neig=size(eig(:))

print*,"total number of filled states:",neig

lname1=80-21-ifirst+1
lname2=5  !ndigits(neig)
fi(1:lname1)=line(21+ifirst:80)
fi(lname1+1:lname1+5 )="-WFN_"
do i=1,lname2
 fi(lname1+5+i:lname1+5+i)="0"
enddo

fi(lname1+5+lname2+1:lname1+5+lname2+11)="_1-1_0.cube"

print*,fi

ntouse=0
eigref=eig(neig)
reached=.false.
i=neig
do while(.not.reached)
 if((-eig(i)+eig(neig))*hartree .gt. abs(vbias)) then
    reached=.true.
 else
    eigref =eig(i)
    i=i-1
    ntouse=ntouse+1
 endif
enddo

reached=.false.
i=i-1
do while(.not.reached)
 if( (-eig(i)+eigref)*hartree .gt. Vthr) then 
  reached=.true.
 else
  eigref=eig(i)
  i=i-1
  ntouse=ntouse+1
 endif
enddo


!!!!!!!!!!!!!END DEFINE RANGE of eigenvalues !!!!!!!!!!!

print*,"I will use ",ntouse," states"

allocate(allorig(vh%nz,ntouse+1))
allocate(allnew(vh%nz,ntouse+1))
allocate(crho(vh%nx,vh%ny,vh%nz))

do i=1,ikmax !vh%nz
 allorig(i,1)=(i-1)*vh%dx(3,3)
 allnew(i,1)=(i-1)*vh%dx(3,3)
enddo

fmts(6-ndigits(ntouse+1)+1:6)=ntouse+1


do istates=neig,neig-ntouse+1,-1   !!!!!!!! MAIN DO

print*, "doing state ",istates

theeig=eig(istates)-vref
rhotmp=0.d0
print*,"the eig",theeig

do i=1,lname2
 fi(lname1+5+i:lname1+5+i)="0"
enddo
fi(lname1+5+lname2-ndigits(istates)+1:lname1+5+lname2)=istates

print*,"reading file ",fi(1:lname1+5+lname2+11)


!!!!!!!!!!!!!!!!!!!!!!!!   READ NEW STATE !!!!!!!!!!!!!!!!!!!!!!!!1111
open(unit=iunit,file=fi,status="unknown")
 call read_cube(c,iunit)
close(unit=iunit)
!!!!!!!!!!!!!!!!!!!!!END   READ NEW STATE !!!!!!!!!!!!!!!!!!!!!!!!1111

print*,"colonna ",neig-istates+2

do i=1,ikmax !c%nz
 allorig(i,neig-istates+2)=accurate_sum(c%rho(1:c%nx,1:c%ny,i)**2)/nxy
enddo
 allnew(1:iplane,neig-istates+2)=allorig(1:iplane,neig-istates+2)

crho=0
lx=c%nx*c%dx(1,1)
ly=c%ny*c%dx(2,2)
scal=1.d0/nxy

sum=accurate_sum(c%rho*c%rho)
!sum=accurate_sum(c%rho)
print*,"cube file norm: ",sum*c%dv


arr=c%rho(1:c%nx,1:c%ny,iplane)

CALL DFFTW_PLAN_DFT_2D(PLAN, l,m, arr, arro, FFTW_FORWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)
!do i=1,l
! do j=1,m
!  write(444,445)arro(i,j)
! enddo
!enddo

!crho(1:c%nx,1:c%ny,1:iplane)=c%rho(1:c%nx,1:c%ny,1:iplane)
!c%rho(1:c%nx,1:c%ny,1:iplane)=c%rho(1:c%nx,1:c%ny,1:iplane)**2


do i=1,c%nx
   if(mod(i,10).eq.0)write(6,50),nint(float(i)/float(c%nx)*100)
   rxy(1)=(i-1) * c%dx(1,1)
 do j=1,c%ny
   rxy(2)=(j-1) * c%dx(2,2)
  do k=iplane+1, ikmax  !c%nz
     znow=(k-1)*c%dx(3,3)

   do ig=1,c%nx
      gvec(1)=2*pi/lx*(ig-1)
      if(ig.gt.c%nx/2+1)gvec(1)=2*pi/lx*(ig-c%nx-1)
    do jg=1,c%ny
      gvec(2)=2*pi/ly*(jg-1)
      if(jg.gt.c%ny/2+1)gvec(2)=2*pi/ly*(jg-c%ny-1)
      val1=-1.d0*dsqrt(-2*theeig + gvec(1)*gvec(1)+gvec(2)*gvec(2))*(znow-zplane)
      val2=gvec(1)*rxy(1) + gvec(2)*rxy(2)
      crho(i,j,k)=crho(i,j,k)+scal*arro(ig,jg)*dexp(val1)*zexp(dcmplx(0.d0,1.d0)*val2)
    enddo
   enddo

!  write(432,433)i,j,k,c%rho(i,j,k),crho(i,j,k)
  enddo
 enddo
enddo


!do i=1,c%nx
!   print*,float(i)/float(c%nx)*100," % done"
!   rxy(1)=(i-1) * c%dx(1,1)
! do j=1,c%ny
!   rxy(2)=(j-1) * c%dx(2,2)
!
!   do ig=1,c%nx
!      gvec(1)=2*pi/lx*(ig-1)
!      if(ig.gt.c%nx/2+1)gvec(1)=2*pi/lx*(ig-c%nx-1)
!    do jg=1,c%ny
!      gvec(2)=2*pi/ly*(jg-1)
!      if(jg.gt.c%ny/2+1)gvec(2)=2*pi/ly*(jg-c%ny-1)
!
!!    val2=gvecs(ig,jg,1)*rvecs(i,j,1) + gvecs(ig,jg,2)*rvecs(i,j,2)
!     val2=gvec(1)*rxy(1) + gvec(2)*rxy(2)
!     zeval2=zexp(dcmplx(0.d0,1.d0)*val2)
!     norma=-1.d0*dsqrt(-2*theeig + gvec(1)*gvec(1)+gvec(2)*gvec(2))
!
!     do k=iplane, iplane+1 !iplane+1 , c%nz
!      znow=(k-1)*c%dx(3,3)
!      val1=norma*(znow-zplane)
!      crho(i,j,k)=crho(i,j,k)+scal*arro(ig,jg)*dexp(val1)*zeval2
!      write(432,433)i,j,k,c%rho(i,j,k),crho(i,j,k)
!     enddo
!
!    enddo
!   enddo
!
! enddo
!enddo


rho(1:c%nx,1:c%ny,1:iplane)       = rho(1:c%nx,1:c%ny,1:iplane)+c%rho(1:c%nx,1:c%ny,1:iplane)**2
rhotmp(1:c%nx,1:c%ny,iplane+1:ikmax) = &
                              real( crho(1:c%nx,1:c%ny,iplane+1:ikmax) * conjg ( crho(1:c%nx,1:c%ny,iplane+1:ikmax) ) )
rho(1:c%nx,1:c%ny,iplane+1:ikmax) = rho(1:c%nx,1:c%ny,iplane+1:ikmax) + rhotmp(1:c%nx,1:c%ny,iplane+1:ikmax)

if(neig-istates+1.eq.ntouse) then
 open(unit=iunit,file=fo,status="unknown")
 c%rho=rho
 call write_cube(c,iunit)
 close(unit=iunit)
endif

call free_cube(c)

do i=iplane+1, ikmax 
 allnew(i,neig-istates+2)=accurate_sum(rhotmp(1:nx,1:ny,i))/nxy
enddo

enddo  !!!!!!!! END MAIN DO

call free_cube(vh)


open(unit=iunit,file="leorig",status="unknown")
 do i=1, ikmax 
  write(iunit,fmts)allorig(i,1:ntouse+1)
 enddo
close(unit=iunit)
open(unit=iunit,file="lenew",status="unknown")
 do i=1,ikmax
  write(iunit,fmts)allnew(i,1:ntouse+1)
 enddo
close(unit=iunit)
open(unit=iunit,file="latotal",status="unknown")
 do i=1,ikmax
  write(iunit,38)allnew(i,1),accurate_sum(rho(1:nx,1:ny,i))/nxy
 enddo
close(unit=iunit)

deallocate(rho)
deallocate(rhotmp)
deallocate(arr)
deallocate(arro)
deallocate(gvecs)
deallocate(ngvecs)
deallocate(rvecs)
deallocate(allorig)
deallocate(allnew)
deallocate(crho)
deallocate(eig)

30 format(4e20.8)
33 format(a80)
45 format(a)
34 format(f12.6,3e20.8)
36 format(2i4,3e20.8)
38 format(2e20.8)
37 continue
50 format(i4," %done")
433 format(3i4,3e20.8)
445 format(2e20.8)


end
