program p

use io
use images
use kahan_sum

implicit none
include "fftw3.f"
!ifort  p.f90 -I /opt/intel/mkl/include/fftw -L /opt/intel/mkl/lib/em64t/ -lfftw3xf_intel -lmkl_intel_ilp64 -lmkl_intel_thread -lmkl_core -liomp5 -lpthread

real*8, allocatable          :: rgb4(:,:)
real*8                       :: dx(2,2),dxo(2,2),gd(2,2),vh1(3),vh2(3),area,r,rxy(2)
real*8                       :: gvec(2),scal,val2,value
complex*16, allocatable      :: in(:,:),tras(:,:),out(:,:)
integer                      :: nx,ny,nxo,nyo,i,j,ig,jg
integer                      :: iunit
integer*8                    :: plan
type(bmp)                    :: b

pi=4.d0*datan(1.d0)

nx=6
ny=6

scal=1.d0/nx/ny
nxo=200
nyo=200
allocate(rgb4(nxo,nyo))

dx=0.d0
dx(1,1)=2.89d0/6   !1.d0
dx(2,1)=dx(1,1)*0.5d0
dx(2,2)=dx(1,1)*0.5d0*dsqrt(3.d0)
vh1(1:2)=dx(1,1:2)*nx
vh2(1:2)=dx(2,1:2)*ny
call vecprod(vh1,vh2)
vh2=0.d0
vh2(3)=1.d0
area=scalar(vh1,vh2)
print*,"area ",area,500*250*dsqrt(3.d0)
vh1=0.d0
vh1(1:2)=dx(2,1:2)*ny
call vecprod(vh1,vh2)
gd(1,1:2)=2*pi*vh1(1:2)/area

vh1=vh2
vh2(1:2)=dx(1,1:2)*nx
vh2(3)=0.d0
call vecprod(vh1,vh2)
gd(2,1:2)=2*pi*vh1(1:2)/area

dxo=0
dxo(1,1)=dx(1,1)/20
dxo(2,2)=dx(2,2)/20

allocate(in(nx,ny),tras(nx,ny),out(nxo,nyo))
out=0


do i=1,nx
 do j=1,ny
   read*,value
   in(i,j)=value
 enddo
enddo

out=dcmplx(0.d0,0.d0)

CALL DFFTW_PLAN_DFT_2D(PLAN, nx,ny, in, tras, FFTW_FORWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)


    do jg=1,ny
   if(mod(jg,10).eq.0) write(6,*)nint(jg*1.d0/ny*100.d0)
   do ig=1,nx

       if(ig.gt.nx/2+1 .and. jg.gt.ny/2+1 ) then
       gvec(1)=gd(1,1)*(ig-nx-1) + gd(2,1)*(jg-ny-1)
       gvec(2)=gd(1,2)*(ig-nx-1) + gd(2,2)*(jg-ny-1)
       else if(ig.gt.nx/2+1) then
       gvec(1)=gd(1,1)*(ig-nx-1) + gd(2,1)*(jg-1)
       gvec(2)=gd(1,2)*(ig-nx-1) + gd(2,2)*(jg-1)
       else if(jg.gt.ny/2+1) then
       gvec(1)=gd(1,1)*(ig-1) + gd(2,1)*(jg-ny-1)
       gvec(2)=gd(1,2)*(ig-1) + gd(2,2)*(jg-ny-1)
       else
       gvec(1)=gd(1,1)*(ig-1) + gd(2,1)*(jg-1)
       gvec(2)=gd(1,2)*(ig-1) + gd(2,2)*(jg-1)
       endif

 do j=1,nyo
   rxy(2)=(j-1) * dxo(2,2)
do i=1,nxo
   rxy(1)=(i-1) * dxo(1,1)


      val2=gvec(1)*rxy(1) + gvec(2)*rxy(2)
      out(i,j)=out(i,j)+scal*tras(ig,jg)*zexp(dcmplx(0.d0,1.d0)*val2)

  
    enddo
   enddo

 enddo
enddo
   rgb4=dreal(out)
open(unit=7,file="out.mth",status="unknown")
do i=1,nxo
 do j=1,nyo
  write(7,37)(i-1) * dxo(1,1),(j-1) * dxo(2,2),rgb4(i,j)
 enddo
enddo

37 format("{",f12.6,",",f12.6,",",f12.6,"},")

close(unit=7)

iunit=12
open(unit=iunit,file="Julio2.clr",status="unknown")

 call uniform2bmp(rgb4,b,iunit)
 open(unit=19,file="out.bmp",status="unknown")
  call write_bmp(b,19)
 close(unit=19)


close(unit=12)

end
