module cg

implicit none

real*8, external :: ddot

contains


subroutine interp_def_row(known,row,nx,ny,ir,jr)
integer, intent(in)        :: nx,ny,ir,jr
logical, intent(in)        :: known(:,:)
real*8, intent(out)        :: row(:)
integer                    :: therow


therow=(ir-1)*ny + jr
row=0.d0

!select case(ir)

if(ir.ge.2.and.ir.le.nx-1) then ! case(2:nx-1) 

!select case(jr)

 if(jr.ge.2.and.jr.le.ny-1)then !case(2:ny-1)         !!!!inner points


  row(therow)=1.d0

  if(.not.known(ir,jr))then

   if(.not.known(ir-1,jr))then
     row(therow-ny)=-0.25d0
   endif
   if(.not.known(ir+1,jr))then
    row(therow+ny)=-0.25d0
   endif
   if(.not.known(ir,jr-1))then
     row(therow-1)=-0.25d0
   endif
   if(.not.known(ir,jr+1))then
     row(therow+1)=-0.25d0
   endif

   endif

 else if(jr.eq.1.or.jr.eq.ny)then !case(1,ny)        !!!!!!!!!!!!!!! lateral columns
  row(therow)=1.d0

   if(.not.known(ir,jr))then

    if(.not.known(ir-1,jr))then
      row(therow-ny)=-0.5d0
    endif

    if(.not.known(ir+1,jr))then
      row(therow+ny)=-0.5d0
    endif

   endif

 endif !end select

else if(ir.eq.1) then !case(1)

! select case(jr)
 if(jr.ge.2.and.jr.le.ny-1)then !case(2:ny-1)       !!!!!!!!1top  row
   row(therow)=1.d0

   if(.not.known(ir,jr))then

    if(.not.known(ir,jr-1))then
      row(therow-1)=-0.5d0
    endif

    if(.not.known(ir,jr+1))then
      row(therow+1)=-0.5d0
    endif

   endif
 else if(jr.eq.1) then !case(1)            !!!!!!!!upper left
  row(therow)=1.d0

  if(.not.known(ir,jr))then

   if(.not.known(ir,jr+1))then
     row(therow+1)=-0.5d0
   endif

   if(.not.known(ir+1,jr))then
     row(therow+ny)=-0.5d0
   endif

  endif 
 else if(jr.eq.ny) then !case(ny)           !!!!!!!!upper right
  row(therow)=1.d0

  if(.not.known(ir,jr))then

   if(.not.known(ir,jr-1))then
     row(therow-1)=-0.5d0
   endif

   if(.not.known(ir+1,jr))then
     row(therow+ny)=-0.5d0
   endif

  endif
 endif !end select

else if(ir.eq.nx) then !case(nx)
!select case(jr)
 if(jr.ge.2.and.jr.le.ny-1) then !case(2:ny-1)       !!!!!!!!1 bottom row
    row(therow)=1.d0

   if(.not.known(ir,jr))then

    if(.not.known(ir,jr-1))then
      row(therow-1)=-0.5d0
    endif

    if(.not.known(ir,jr+1))then
      row(therow+1)=-0.5d0
    endif

   endif
 else if(jr.eq.1) then !case(1)            !!!!!!!! bottom left
  row(therow)=1.d0

  if(.not.known(ir,jr))then

   if(.not.known(ir,jr+1))then
     row(therow+1)=-0.5d0
   endif

   if(known(ir-1,jr))then
      row(therow-ny)=-0.5d0
   endif

  endif
 else if(jr.eq.ny) then !case(ny)           !!!!!!!! bottom right
  row(therow)=1.d0

  if(.not.known(ir,jr))then

   if(.not.known(ir,jr-1))then
     row(therow-1)=-0.5d0
   endif

    if(.not.known(ir-1,jr))then
      row(therow-ny)=-0.5d0
    endif

  endif
 endif !end select

endif !end select


end subroutine interp_def_row

subroutine interp_def_b(val,known,b,nx,ny,ir,jr)
real*8,  intent(in)        :: val(:,:)
integer, intent(in)        :: nx,ny,ir,jr
logical, intent(in)        :: known(:,:)
real*8, intent(out)        :: b! (:)
integer                    :: therow


!therow=(ir-1)*ny + jr
b=0.d0

!select case(ir)

if(ir.ge.2.and.ir.le.nx-1)then !case(2:nx-1)

! select case(jr)

 if(jr.ge.2.and.jr.le.ny-1)then !case(2:ny-1)         !!!!inner points

   if(known(ir,jr))then
!   b(therow)=val(ir,jr)
    b=val(ir,jr)
   else


    if(known(ir-1,jr))then
      b=b+0.25d0*val(ir-1,jr)
!     b(therow)=b(therow)+0.25d0*val(ir-1,jr)
    endif


    if(known(ir+1,jr))then
!     b(therow)=b(therow)+0.25d0*val(ir+1,jr)
      b=b+0.25d0*val(ir+1,jr)
    endif

    if(known(ir,jr-1))then
!     b(therow)=b(therow)+0.25d0*val(ir,jr-1)
      b=b+0.25d0*val(ir,jr-1)
    endif

    if(known(ir,jr+1))then
!     b(therow)=b(therow)+0.25d0*val(ir,jr+1)
      b=b+0.25d0*val(ir,jr+1)
    endif

   endif

 else if(jr.eq.1.or.jr.eq.ny)then !case(1,ny)        !!!!!!!!!!!!!!! lateral columns

   if(known(ir,jr))then
!   b(therow)=val(ir,jr)
    b=val(ir,jr)
   else

    if(known(ir-1,jr))then
!     b(therow)=b(therow)+0.5d0*val(ir-1,jr)
      b=b+0.5d0*val(ir-1,jr)
    endif

    if(known(ir+1,jr))then
!     b(therow)=b(therow)+0.5d0*val(ir+1,jr)
      b=b+0.5d0*val(ir+1,jr)
    endif

   endif
 endif !end select

else if(ir.eq.1)then !case(1)

!select case(jr)
 if(jr.ge.2.and.jr.le.ny-1)then !case(2:ny-1)       !!!!!!!!1top  row

   if(known(ir,jr))then
!   b(therow)=val(ir,jr)
    b=val(ir,jr)
   else

    if(known(ir,jr-1))then
!     b(therow)=b(therow)+0.5d0*val(ir,jr-1)
      b=b+0.5d0*val(ir,jr-1)
    endif

    if(known(ir,jr+1))then
!     b(therow)=b(therow)+0.5d0*val(ir,jr+1)
      b=b+0.5d0*val(ir,jr+1)
    endif

   endif
 else if(jr.eq.1) then !case(1)            !!!!!!!!upper left

  if(known(ir,jr))then
!  b(therow)=val(ir,jr)
   b=val(ir,jr)
  else

   if(known(ir,jr+1))then
!    b(therow)=b(therow)+0.5d0*val(ir,jr+1)
     b=b+0.5d0*val(ir,jr+1)
   endif

   if(known(ir+1,jr))then
!    b(therow)=b(therow)+0.5d0*val(ir+1,jr)
     b=b+0.5d0*val(ir+1,jr)
   endif

  endif
 else if(jr.eq.ny)then !case(ny)           !!!!!!!!upper right

  if(known(ir,jr))then
!  b(therow)=val(ir,jr)
   b=val(ir,jr)
  else

   if(known(ir,jr-1))then
!    b(therow)=b(therow)+0.5d0*val(ir,jr-1)
     b=b+0.5d0*val(ir,jr-1)
   endif

   if(known(ir+1,jr))then
!    b(therow)=b(therow)+0.5d0*val(ir+1,jr)
     b=b+0.5d0*val(ir+1,jr)
   endif

  endif
 endif !end select

else if(ir.eq.nx)then !case(nx)
!select case(jr)
 if(jr.ge.2.and.jr.le.ny-1)then !case(2:ny-1)       !!!!!!!!1 bottom row

   if(known(ir,jr))then
!   b(therow)=val(ir,jr)
    b=val(ir,jr)
   else
 
    if(known(ir,jr-1))then
!     b(therow)=b(therow)+0.5d0*val(ir,jr-1)
      b=b+0.5d0*val(ir,jr-1)
    endif
 
    if(known(ir,jr+1))then
!     b(therow)=b(therow)+0.5d0*val(ir,jr+1)
      b=b+0.5d0*val(ir,jr+1)
    endif
 
   endif
 else if(jr.eq.1) then !case(1)            !!!!!!!! bottom left

  if(known(ir,jr))then
!  b(therow)=val(ir,jr)
   b=val(ir,jr)
  else

   if(known(ir,jr+1))then
!    b(therow)=b(therow)+0.5d0*val(ir,jr+1)
     b=b+0.5d0*val(ir,jr+1)
   endif

    if(known(ir-1,jr))then
!     b(therow)=b(therow)+0.5d0*val(ir-1,jr)
      b=b+0.5d0*val(ir-1,jr)
    endif

  endif
 else if(jr.eq.ny)then !case(ny)           !!!!!!!! bottom right

  if(known(ir,jr))then
!  b(therow)=val(ir,jr)
   b=val(ir,jr)
  else

   if(known(ir,jr-1))then
!    b(therow)=b(therow)+0.5d0*val(ir,jr-1)
     b=b+0.5d0*val(ir,jr-1)
   endif

    if(known(ir-1,jr))then
!     b(therow)=b(therow)+0.5d0*val(ir-1,jr)
      b=b+0.5d0*val(ir-1,jr)
    endif

  endif
 endif!end select

endif!end select
end subroutine interp_def_b

end module cg
