program add_rho_core

use tricks
use io


implicit none

type(cube)           :: c
type(geo)            :: g
real*8, allocatable  :: rhoc(:,:,:),rhon1(:,:,:)
real*8               :: dxn(3,3),q,v(3),r(12),basis(3,3),dd,rr,volfac,d
real*8               :: d1,d2,d3,rcut,rcut0
real*8               :: bb(3)
real*8               :: ld(3),lu(3),lr(3),ll(3),ud(3),uu(3),ur(3),ul(3),t(3)
integer              :: i,j,k,n,m,nxn,nyn,nzn,nr(100),vi(3),v0(3),theatom(12)
integer              :: ii,jj,kk,ia,id,columns,dig,m1,m2,m3,ia1,ia2
integer              :: si,sj,sk,idsp(100),spid(100),nsp,thesp,dumn,nrmax
integer              :: npar,naperproc,iunit,nx,ny,nz
integer              :: bimin,bimax,bjmin,bjmax,bkmin,bkmax,bounds(8,3) ,p0(3)
integer, allocatable :: count(:,:,:)
logical              :: thereis_sp(100)
character(len=30)    :: fi,fo,frt
character(len=30)    :: fr(100)
character(LEN=10)    :: fmts

frt="rhoval"
fo="rhov.cube"
fr=""
nrmax=2000

do i=1,100
 dumn=ndigits(i)
 fr(i)(1:6)=frt(1:6)
 fr(i)(7:6+dumn)=i
enddo

fmts="(   e17.9)"



dig=ndigits(id)

print*,"name xyz file"
read(*,33)fi

iunit=13
open(unit=iunit,file=fi,status="unknown")
 call read_geo(g,fi,iunit)
close(unit=iunit)

print*,"give me lattice vectors in A"
read*,g%b(1,1:3)
read*,g%b(2,1:3)
read*,g%b(3,1:3)
print*,"give me nx,ny,nz"
read*,nx,ny,nz

basis=g%b/0.529177d0

print*,g%name(3),g%p(3,1:3)
call geo2cube(g,c,nx,ny,nz)

print*,"vol element ",c%dv,c%dx(1,1:3),c%dx(2,1:3),c%dx(3,1:3)


!! CONTA numero specie per aprire i file rhoc
nsp=0
spid=0
thereis_sp=.false.
do i=1,c%natoms     
  thereis_sp(c%dumn(i))=.true.
enddo
do i=1,100     
  if( thereis_sp(i) ) then
   nsp=nsp+1
   idsp(nsp)=i
   spid(i)=nsp
  endif
enddo
!! FINE CONTA specie

allocate(rhoc(nsp,nrmax,2))
rhoc=0
rcut=-5000
rcut0=5000
do i=1,nsp

 open(unit=7,file=fr(idsp(i)),status="unknown")

 read(7,*)nr(i)
 if(nr(i).gt.nrmax) then
   print *,"increase nrmax"
   stop
 endif
 do j=1,nr(i)
  read(7,*)rhoc(i,j,1:2)
 enddo
 close(unit=7)

 write(6,*)"letto da ",fr(idsp(i)),nr(i)," punti"
 if(rhoc(i,nr(i),1).gt.rcut) rcut=rhoc(i,nr(i),1)
 if(rhoc(i,2,1).lt.rcut0) rcut0=rhoc(i,2,1)

enddo

print*,"rcut is ",rcut
t=0.d0
ld=0.d0
ld(2)=-rcut
lu=0.d0
lu(2)=rcut
lr=0.d0
lr(1)=rcut
ll=0.d0
ll(1)=-rcut
ud=0.d0
ud(2)=-rcut
ud(3)=rcut
uu=0.d0
uu(3)=rcut
uu(2)=rcut
ur=0.d0
ur(3)=rcut
ur(1)=rcut
ul=0
ul(1)=-rcut
ul(3)=rcut

    bb=t+ld
    call ijk(bounds(1,1:3),bb,c%dx)
    bb=t+lu
    call ijk(bounds(2,1:3),bb,c%dx)
    bb=t+lr
    call ijk(bounds(3,1:3),bb,c%dx)
    bb=t+ll
    call ijk(bounds(4,1:3),bb,c%dx)
    bb=t+ud
    call ijk(bounds(5,1:3),bb,c%dx)
    bb=t+uu
    call ijk(bounds(6,1:3),bb,c%dx)
    bb=t+ur
    call ijk(bounds(7,1:3),bb,c%dx)
    bb=t+ul
    call ijk(bounds(8,1:3),bb,c%dx)
    bimin=minval(bounds(1:8,1))
    bimax=maxval(bounds(1:8,1))
    bjmin=minval(bounds(1:8,2))
    bjmax=maxval(bounds(1:8,2))
    bkmin=minval(bounds(1:8,3))
    bkmax=maxval(bounds(1:8,3))



allocate(rhon1(c%nx,c%ny,c%nz))

rhon1=0.d0

do ia=1,c%natoms
 if(mod(ia,5).eq.0)print*,"done ",int(1.d0*ia/c%natoms*100) ," %"
 call ijk(v0,c%pos(ia,1:3),c%dx)
 do i=bimin+v0(1),bimax+v0(1)
  vi(1)=i
  do j=bjmin+v0(2),bjmax+v0(2)
   vi(2)=j
   do k=bkmin+v0(3),bkmax+v0(3)
    vi(3)=k
    call xyz(vi,v,c%dx)
    p0=vi
    d1=distanza(v,c%pos(ia,1:3),basis)
    thesp=spid(c%dumn(ia))
    call pbci(p0,nx,ny,nz) 
    rhon1(p0(1),p0(2),p0(3))=rhon1(p0(1),p0(2),p0(3))+rc(d1,rhoc(thesp,1:nr(thesp),1:2))
   enddo
  enddo
 enddo
enddo
!do ia=1,c%natoms
!
! thesp=spid(c%dumn(ia))
! print*,"doing atom ",ia,thesp
! v=c%pos(ia,1:3)
!
! do si=-1,1,2
! do sj=-1,1,2
! do sk=-1,1,2
!
!  do i=2,nr(thesp)-1
!    v(1)=c%pos(ia,1)+si*rhoc(thesp,i,1) 
!    d1=rhoc(thesp,i,1)*rhoc(thesp,i,1)
!   do j=2,nr(thesp)-1
!     v(2)=c%pos(ia,2)+sj*rhoc(thesp,j,1) 
!     d2=rhoc(thesp,j,1)*rhoc(thesp,j,1)
!    do k=2,nr(thesp)-1
!     volfac=(rhoc(thesp,i+1,1)-rhoc(thesp,i-1,1))*(rhoc(thesp,j+1,1)-rhoc(thesp,j-1,1))*(rhoc(thesp,k+1,1)-rhoc(thesp,k-1,1))/8
!     volfac=volfac/c%dv
!     v(3)=c%pos(ia,3)+sk*rhoc(thesp,k,1) 
!     d3=rhoc(thesp,k,1)*rhoc(thesp,k,1)
!     d=dsqrt(d1+d2+d3) 
!     call ijk(vi,v,c%dx)
!     call pbci(vi,c%nx,c%ny,c%nz)
!     ii=vi(1)
!     jj=vi(2)
!     kk=vi(3)
!!    count(ii,jj,kk)=count(ii,jj,kk)+1
!     rhon1(ii,jj,kk)=rhon1(ii,jj,kk)+rc(d,rhoc(thesp,1:nr(thesp),1:2))*volfac
!    enddo
!   enddo
!  enddo
!
!
! enddo
! enddo  !segni -1 e +1
! enddo 
!!rhon=rhon+rhon1
! write(6,*)ia,sum(rhon1(1:c%nx,1:c%ny,1:c%nz))*c%dv
!
!
!enddo

c%rho=rhon1 
 write(6,*)sum(rhon1(1:c%nx,1:c%ny,1:c%nz))*c%dv

iunit=13
open(unit=13,file=fo,status="unknown")
 call write_cube(c,iunit)
close(unit=13)


deallocate(rhon1)
call free_cube(c)
call destroy_geo(g)



33 format(a)

end
