module fft_operations

use operations
use tricks

implicit none
include "fftw3.f"

contains

subroutine interp_fftw(rgb2,rgb4,fac,dxi,dxoi,io,nprocs)


real*8, allocatable ,intent(out)         :: rgb4(:,:)
real*8, intent(in)                       :: rgb2(:,:)
real*8, intent(in)                       :: dxi(:,:),dxoi(:,:),fac  !dx(2,2),dxo(2,2)
real*8                                   :: gd(2,2),vh1(3),vh2(3),area,r,rxy(2),dx(3,3),dxo(3,3)
real*8                                   :: gvec(2),scal,val2
complex*16, allocatable                  :: in(:,:),tras(:,:),out(:,:)
integer                                  :: nx,ny,nxo,nyo,i,j,ig,jg,from, to
integer, optional                        :: io,nprocs
integer*8                                :: plan

pi=4.d0*datan(1.d0)

nx=size(rgb2,1)
ny=size(rgb2,2)
!print*,"nx ny ",nx,ny

scal=1.d0/nx/ny
dx=dxi
dxo=dxoi

vh1(1:2)=dx(1,1:2) !*nx
vh2(1:2)=dx(2,1:2) !*ny
call vecprod(vh1,vh2)
vh2=0.d0
vh2(3)=1.d0
area=scalar(vh1,vh2)
vh1=0.d0
vh1(1:2)=dx(2,1:2)
call vecprod(vh1,vh2)
gd(1,1:2)=2*pi*vh1(1:2)/area

vh1=vh2
vh2(1:2)=dx(1,1:2)
vh2(3)=0.d0
call vecprod(vh1,vh2)
gd(2,1:2)=2*pi*vh1(1:2)/area
!print*,area,gd(1,1:2),gd(2,1:2)

nxo=dxo(1,1)/(min(norm(dx(1,1:2)/nx),norm(dx(2,1:2)/ny))*fac)
nyo=dxo(2,2)/(min(norm(dx(1,1:2)/nx),norm(dx(2,1:2)/ny))*fac)
if(mod(nxo,4).gt.0) nxo=((nxo/4)+1)*4
if(mod(nyo,4).gt.0) nyo=((nyo/4)+1)*4
allocate(rgb4(nxo,nyo))
rgb4=0.d0

dxo(1,1:2)=dxo(1,1:2)/nxo
dxo(2,1:2)=dxo(2,1:2)/nyo

allocate(in(nx,ny),tras(nx,ny),out(nxo,nyo))

in=rgb2
!do i=1,nx
! do j=1,ny
!   in(i,j)=dcmplx(rgb2(i,j),0.d0)
! enddo
!enddo
!do i=1,nx
! do j=1,ny
!   write(404,405)in(i,j),tras(i,j)
! enddo
!enddo

tras=dcmplx(0.d0,0.d0)
out=dcmplx(0.d0,0.d0)

CALL DFFTW_PLAN_DFT_2D(PLAN, nx,ny, in, tras, FFTW_FORWARD,FFTW_ESTIMATE)
CALL DFFTW_EXECUTE(PLAN)
CALL DFFTW_DESTROY_PLAN(PLAN)
if(present(io)) then
 call intervals(nyo,nprocs,io,from,to)
else
 from=1
 to=nyo 
endif
!write(404,*)"dopo"
!do i=1,nx
! do j=1,ny
!   write(404,405)in(i,j),tras(i,j)
! enddo
!enddo

    do jg=1,ny
   do ig=1,nx

       if(ig.gt.nx/2+1 .and. jg.gt.ny/2+1 ) then
       gvec(1)=gd(1,1)*(ig-nx-1) + gd(2,1)*(jg-ny-1)
       gvec(2)=gd(1,2)*(ig-nx-1) + gd(2,2)*(jg-ny-1)
       else if(ig.gt.nx/2+1) then
       gvec(1)=gd(1,1)*(ig-nx-1) + gd(2,1)*(jg-1)
       gvec(2)=gd(1,2)*(ig-nx-1) + gd(2,2)*(jg-1)
       else if(jg.gt.ny/2+1) then
       gvec(1)=gd(1,1)*(ig-1) + gd(2,1)*(jg-ny-1)
       gvec(2)=gd(1,2)*(ig-1) + gd(2,2)*(jg-ny-1)
       else
       gvec(1)=gd(1,1)*(ig-1) + gd(2,1)*(jg-1)
       gvec(2)=gd(1,2)*(ig-1) + gd(2,2)*(jg-1)
       endif

 do j=from,to
   rxy(2)=(j-1) * dxo(2,2)
do i=1,nxo
   rxy(1)=(i-1) * dxo(1,1)


      val2=gvec(1)*rxy(1) + gvec(2)*rxy(2)
      out(i,j)=out(i,j)+scal*tras(ig,jg)*zexp(dcmplx(0.d0,1.d0)*val2)


    enddo
   enddo

 enddo
enddo
   rgb4=dreal(out)

405 format(4g20.8)

end subroutine interp_fftw



end module fft_operations
