module geometry

use periodic_table

implicit none

type geo 

real*8, pointer          :: p(:,:)
character(len=2),pointer :: name(:)
character(len=3)         :: fmt
real*8                   :: b(3,3)
integer                  :: n

end type geo

interface assignment(=)
 module procedure geo_eq_geo
end interface

contains

subroutine geo_eq_geo(g1,g2)
type(geo),intent(in)          :: g2
type(geo),intent(inout)       :: g1

call create_geo(g1,g2%n)
g1%p=g2%p
g1%name=g2%name
g1%fmt=g2%fmt
g1%b=g2%b
g1%n=g2%n

end subroutine geo_eq_geo

subroutine destroy_geo(g)
type(geo), intent(inout)     :: g
deallocate(g%p)
deallocate(g%name)
end subroutine destroy_geo

subroutine create_geo(g,n)
type(geo), intent(out)        :: g
integer, intent(in)           :: n

if(associated(g%p)) deallocate(g%p)
allocate(g%p(n,3))
g%p=0.d0
if(associated(g%name)) deallocate(g%name)
allocate(g%name(n))
g%n=n

end subroutine create_geo

subroutine write_vmd_sphere(p,r,c,iuni)
 real*8, intent(in)      :: p(3),r,c
 integer, intent(in)     :: iuni

 write(iuni,33)p,r,c

 33 format("draw sphere {" ,3f12.6, "} radius " ,f12.6, " color " ,f10.4, " resolution 20")
end subroutine write_vmd_sphere

subroutine write_vmd_triangle(p1,p2,p3,c,iuni)
 real*8, intent(in)      :: p1(3),p2(3),p3(3),c
 integer, intent(in)     :: iuni

 write(iuni,33)p1,p2,p3  !,c

 33 format("draw triangle {" ,3f12.6, "} {" ,3f12.6, "} {" ,3f12.6, "}" )
end subroutine write_vmd_triangle

integer function atnum(hn)
IMPLICIT NONE
character(len=*), intent(in) :: hn
character(len=2) :: n,hm
integer :: i,j,k
n='  '
n=adjustl(trim(hn))
atnum=333; i=1 !(k+1:k+2)
 do while (i<106)
!  mi=ptable(atnum(g%name(i)))%amass 
   hm=ptable(i)%symbol
!  if (scan(hm,n).gt.0) then
   if (hm(1:2)==n) then
    atnum=i
    exit
   end if 
   i=i+1
 end do
end function atnum


end module geometry
