module io

use tricks
!use cubefile
use cube_op
!use operations
!use geometry

implicit none

contains


subroutine linexmgr(p1,p2,w,c,iuni)
real*8, intent(in)   :: p1(2),p2(2),w
integer, intent(in)  :: c,iuni

   write(iuni,33)"@with line"
   write(iuni,33)"@    line on"
   write(iuni,33)"@    line loctype world"
   write(iuni,33)"@    line g0"
   write(iuni,34)"@    line",p1(1),p1(2),p2(1),p2(2)
   write(iuni,35)"@    line linewidth ",w
   write(iuni,33)"@    line linestyle 1"
   write(iuni,36)"@    line color ",c
   write(iuni,33)"@    line arrow 0"
   write(iuni,33)"@    line arrow type 0"
   write(iuni,33)"@    line arrow length 1.000000"
   write(iuni,33)"@    line arrow layout 1.000000, 1.000000"
   write(iuni,33)"@line def"

33 format(a)
34 format(a,f12.6,", ",f12.6,", ",f12.6,", ",f12.6)
35 format(a,f7.3)
36 format(a,i4)


end subroutine linexmgr


subroutine arrowxmgr(p1,p2,w,c,iuni)
real*8, intent(in)   :: p1(2),p2(2),w
integer, intent(in)  :: c,iuni

   write(iuni,33)"@with line"
   write(iuni,33)"@    line on"
   write(iuni,33)"@    line loctype world"
   write(iuni,33)"@    line g0"
   write(iuni,34)"@    line",p1(1),p1(2),p2(1),p2(2)
   write(iuni,35)"@    line linewidth ",w
   write(iuni,33)"@    line linestyle 1"
   write(iuni,36)"@    line color ",c
   write(iuni,33)"@    line arrow 2"
   write(iuni,33)"@    line arrow type 0"
   write(iuni,33)"@    line arrow length 0.300000"
   write(iuni,33)"@    line arrow layout 1.000000, 1.000000"
   write(iuni,33)"@line def"

33 format(a)
34 format(a,f12.6,", ",f12.6,", ",f12.6,", ",f12.6)
35 format(a,f7.3)
36 format(a,i4)


end subroutine arrowxmgr

subroutine read_cp2k_eig(eig,iunit)

integer, intent(in)                       :: iunit
real*8, allocatable, intent(out)          :: eig(:)
integer                                   :: i,nelec,n1
character(len=27)                         :: sce
character(len=19)                         :: scn
character(len=120)                        :: line

sce="Eigenvalues of the occupied"
scn="Number of electrons"

line=""
do while(.not.thereis(line,scn))
 read(iunit,33,END=37)line
enddo
 
i=whereis(line,scn)
read(line(i+21:120),*)nelec
allocate(eig(nelec/2))


do while(.not.thereis(line,sce))
 read(iunit,33,END=37)line
enddo

 read(iunit,33,END=37)line

n1=nelec/2/4
do i=1,n1
 read(iunit,*)eig(4*(i-1)+1:4*i)
enddo
if(4*n1.lt.nelec/2)read(iunit,*)eig(4*n1+1:nelec/2)

33 format(a120)
37 continue


end subroutine read_cp2k_eig

subroutine read_cp2k_restart(g,v,iuni)
type(geo), intent(out)                    :: g
type(geo), intent(out),optional           :: v
integer, intent(in)                       :: iuni
character(len=120)                        :: line
character(len=5)                          :: sc
character(len=9)                          :: sce
character(len=8)                          :: sv
character(len=12)                         :: sve
character(len=6)                          :: ss
character(len=10)                         :: sse
character(len=4)                          :: scel
character(len=8)                          :: scele
integer                                   :: fc,n,in
character(len=2)                          :: name(30000)
real*8                                    :: pos(30000,3)

sc="COORD"
sce="END COORD"
sv="VELOCITY"
sve="END VELOCITY"
ss="SUBSYS"
sse="END SUBSYS"
scel="CELL"
scele="END CELL"

line=""
do while(thereis(line,sse))
 line=""
 in=0
 read(iuni,33,END=37)line
 if(thereis(line,ss))then
  do while(thereis(line,scel))
   read(iuni,33,END=37)line
  enddo
  read(iuni,33,END=37)line
  fc=first_char(line)
  read(line(fc+1:120),*)g%b(1,1:3)
  read(iuni,33,END=37)line
  fc=first_char(line)
  read(line(fc+1:120),*)g%b(2,1:3)
  read(iuni,33,END=37)line
  fc=first_char(line)
  read(line(fc+1:120),*)g%b(3,1:3)
  do while(thereis(line,scele))
   read(iuni,33,END=37)line
  enddo
 endif
 if(thereis(line,sc)) then
   do while(thereis(line,sce))
    read(iuni,33,END=37)line
    in=in+1
    fc=first_char(line) 
    name(in)=line(fc:fc+1) 
    read(line(fc+2:120),*)pos(in,1:3)
   enddo
   allocate(g%p(in,3))
   allocate(g%name(in))
   g%n=in
   g%fmt="xyz"
   g%p(1:in,1:3)=pos(1:in,1:3)
   g%name(1:in)=name(1:in)
 endif
 if(present(v)) then
  if(thereis(line,sv)) then
   do while(thereis(line,sve))
    read(iuni,33,END=37)line
    in=in+1
    read(line,*)pos(in,1:3)
   enddo
   allocate(v%p(in,3))
   allocate(v%name(in))
   v%n=in
   v%fmt="xyz"
   v%p(1:in,1:3)=pos(1:in,1:3)
   v%name="XX"
  endif
 endif


enddo


33 format(a120)
37 continue


end subroutine read_cp2k_restart


subroutine read_cube_pw(s,iunit)
type(cube)                       :: s
integer, intent(in)              :: iunit
character (len=75)               :: title
character (len=3), allocatable   :: atm(:)
integer                          :: i,j,k,ibrav,ipol,incr,ir,na,ndum,nt
integer                          :: nrx1, nrx2, nrx3, nr1, nr2, nr3, nat, ntyp
integer, allocatable             :: ityp(:)
real*8                           :: celldm(6),dumr,rfac,base(3,3)
real*8, allocatable              :: plot(:),zv(:)

rfac=1.d0

     read (iunit, '(a)') title
     read (iunit, * ) nrx1, nrx2, nrx3, nr1, nr2, nr3, nat, ntyp
     allocate(atm(ntyp))
     allocate(zv(ntyp))
     allocate(ityp(nat))
     allocate(plot(nrx1*nrx2*nrx3))
s%natoms=nat
s%nx=nrx1
s%ny=nrx2
s%nz=nrx3
allocate(s%pos(s%natoms,3))
allocate(s%dumr(s%natoms))
allocate(s%dumn(s%natoms))
allocate(s%rho(s%nx,s%ny,s%nz))
     read (iunit, * ) ibrav, celldm
     if (ibrav == 0) then
        do i = 1,3
           read ( iunit, * ) ( s%dx(i,ipol),ipol=1,3 )
        enddo
        s%dx=s%dx*celldm(1)
        base=s%dx
        s%dx(1,1:3)=s%dx(1,1:3)/s%nx
        s%dx(2,1:3)=s%dx(2,1:3)/s%ny
        s%dx(3,1:3)=s%dx(3,1:3)/s%nz
        rfac=celldm(1)
     else
        call  celldm2basis(celldm,s%dx)
        s%dx(1,1:3)=s%dx(1,1:3)/s%nx
        s%dx(2,1:3)=s%dx(2,1:3)/s%ny
        s%dx(3,1:3)=s%dx(3,1:3)/s%nz
     endif
     read (iunit, * ) dumr,dumr,dumr,dumr !gcutm, dual, ecut, plot_num
     read (iunit, '(i4,3x,a2,3x,f5.2)') &
             (ndum, atm(nt), zv(nt), nt=1, ntyp)
     read (iunit, *) (s%dumn(na),  (s%pos ( na,ipol), ipol = 1, 3), &
             ityp(na), na = 1, nat)
     read (iunit, * ) (plot (ir), ir = 1, nrx1 * nrx2 * nrx3)

     incr=0
     do i=1,s%natoms
      s%dumr(i)=zv(ityp(i))
     enddo

     do k=1,s%nz
      do j=1,s%ny
       do i=1,s%nx
     
         incr=incr+1
         s%rho(i,j,k)=plot(incr)

       enddo
      enddo
     enddo


     s%pos=s%pos*rfac
     call pbc(s%pos,base)

s%dv = dabs( s%dx(3,1)*(s%dx(1,2)*s%dx(2,3) - s%dx(1,3)*s%dx(2,2)) +  &
             s%dx(3,2)*(s%dx(1,1)*s%dx(2,3) - s%dx(1,3)*s%dx(2,1)) +  &
             s%dx(3,3)*(s%dx(1,1)*s%dx(2,2) - s%dx(1,2)*s%dx(2,1))   )

s%q=sum(s%rho(:,:,:)) * s%dv
s%offset=0.d0
s%header(1)="PRESO DA"
s%header(2)="PWSCF"

deallocate(plot)
deallocate(atm)
deallocate(ityp)
deallocate(zv)

return
end subroutine read_cube_pw

subroutine read_cube(s,iunit)

type(cube)                       :: s
integer                          :: i,j,k
integer, intent(in)              :: iunit


read(iunit,*) 
read(iunit,*) 
read(iunit,*) s%natoms,s%offset(1:3)
read(iunit,*) s%nx,s%dx(1,1:3)
read(iunit,*) s%ny,s%dx(2,1:3)
read(iunit,*) s%nz,s%dx(3,1:3)

allocate(s%pos(s%natoms,3))
allocate(s%dumr(s%natoms))
allocate(s%dumn(s%natoms))
allocate(s%rho(s%nx,s%ny,s%nz))

do i=1,s%natoms
 read(iunit,*)s%dumn(i),s%dumr(i),s%pos(i,1),s%pos(i,2),s%pos(i,3)
enddo
do i=1,s%nx
 do j=1,s%ny
  read(iunit,*)(s%rho(i,j,k),k=1,s%nz)
 enddo
enddo


s%dv = dabs( s%dx(3,1)*(s%dx(1,2)*s%dx(2,3) - s%dx(1,3)*s%dx(2,2)) +  & 
             s%dx(3,2)*(s%dx(1,1)*s%dx(2,3) - s%dx(1,3)*s%dx(2,1)) +  &
             s%dx(3,3)*(s%dx(1,1)*s%dx(2,2) - s%dx(1,2)*s%dx(2,1))   )

s%q=sum(s%rho(:,:,:)) * s%dv

return

end subroutine read_cube

subroutine read_multicube(s,n,iunit)

integer, intent(in)              :: n,iunit
type(cube)                       :: s
integer                          :: i,j,k


read(iunit,*)
read(iunit,*)
read(iunit,*) s%natoms,s%offset(1:3)
read(iunit,*) s%nx,s%dx(1,1:3)
read(iunit,*) s%ny,s%dx(2,1:3)
read(iunit,*) s%nz,s%dx(3,1:3)

allocate(s%pos(s%natoms,3))
allocate(s%dumr(s%natoms))
allocate(s%dumn(s%natoms))
allocate(s%rho(s%nx,s%ny,s%nz*n))

do i=1,s%natoms
 read(iunit,*)s%dumn(i),s%dumr(i),s%pos(i,1),s%pos(i,2),s%pos(i,3)
enddo
do i=1,s%nx
 do j=1,s%ny
  read(iunit,*)(s%rho(i,j,k),k=1,s%nz*n)
 enddo
enddo


s%dv = dabs( s%dx(3,1)*(s%dx(1,2)*s%dx(2,3) - s%dx(1,3)*s%dx(2,2)) +  &
             s%dx(3,2)*(s%dx(1,1)*s%dx(2,3) - s%dx(1,3)*s%dx(2,1)) +  &
             s%dx(3,3)*(s%dx(1,1)*s%dx(2,2) - s%dx(1,2)*s%dx(2,1))   )

s%q=sum(s%rho(:,:,:)) * s%dv

return

end subroutine read_multicube

subroutine replica_cube(s,ix,iy,iz)
type(cube), intent(inout)             :: s
real*8, allocatable                   :: newrho(:,:,:),newpos(:,:),newdumn(:),newdumr(:)
real*8                                :: v(3),a1(3),a2(3),a3(3)
integer                               :: i,j,k,ii,jj,kk,newnatoms,theatom,ix,iy,iz,ia
integer                               :: newnx,newny,newnz

newnx=s%nx*ix
newny=s%ny*iy
newnz=s%nz*iz
newnatoms=s%natoms*ix*iy*iz
a1=s%dx(1,1:3)*s%nx
a2=s%dx(2,1:3)*s%ny
a3=s%dx(3,1:3)*s%nz
allocate(newpos(newnatoms,3))
allocate(newrho(newnx,newny,newnz))
allocate(newdumn(newnatoms))
allocate(newdumr(newnatoms))
theatom=0
do i=0,ix-1
 do j=0,iy-1
  do k=0,iz-1

    do ii=1,s%nx
     do jj=1,s%ny
      do kk=1,s%nz
        newrho(ii+i*s%nx,jj+j*s%ny,kk+k*s%nz)=s%rho(ii,jj,kk)
      enddo
     enddo
    enddo
       do ia=1,s%natoms
         theatom=theatom+1
         v=i*a1+j*a2+k*a3
         newpos(theatom,1:3)=s%pos(ia,1:3)+v
         newdumn(theatom)=s%dumn(ia)
         newdumr(theatom)=s%dumr(ia)
       enddo

  enddo
 enddo
enddo

deallocate(s%rho)
deallocate(s%pos)
deallocate(s%dumn)
deallocate(s%dumr)
allocate(s%pos(newnatoms,3))
allocate(s%rho(newnx,newny,newnz))
allocate(s%dumn(newnatoms))
allocate(s%dumr(newnatoms))
s%pos=newpos
s%rho=newrho
s%natoms=newnatoms
s%nx=newnx
s%ny=newny
s%nz=newnz
s%dumn=newdumn
s%dumr=newdumr
deallocate(newrho)
deallocate(newpos)
deallocate(newdumn)
deallocate(newdumr)

return

end subroutine replica_cube


subroutine write_cube(s,iunit)

type(cube), intent(in)        :: s
integer, intent(in)           :: iunit
integer                       :: i,j,k,kk,columns
character(LEN=10)             :: fmts

fmts="(   e13.5)"

!nx=size(rho(:,1,1))
!ny=size(rho(1,:,1))
!nz=size(rho(1,1,:))

columns=mod(s%nz,6)



write(iunit,*)"filecube"
write(iunit,*)"filecube"
write(iunit,36)s%natoms,s%offset
write(iunit,36)s%nx,s%dx(1,1:3)
write(iunit,36)s%ny,s%dx(2,1:3)
write(iunit,36)s%nz,s%dx(3,1:3)

do i=1,s%natoms
 write(iunit,37)s%dumn(i),s%dumr(i),s%pos(i,1:3)
enddo


select case(columns)

 case(0:0)

do i=1,s%nx
 do j=1,s%ny
  do k=1,s%nz,6
    write(iunit,44)(s%rho(i,j,k+kk),kk=0,5)
  enddo
 enddo
enddo

 case(1:5)

write(fmts(4:4),33)columns
do i=1,s%nx
 do j=1,s%ny
  do k=1,s%nz-6,6
  write(iunit,44)(s%rho(i,j,k+kk),kk=0,5)
  enddo
  write(iunit,fmts)(s%rho(i,j,s%nz-columns+kk),kk=1,columns)
 enddo
enddo

end select


33 format(i1)
36 format(i4,3f12.6)
37 format(i4,4f12.6)
44 format(6e13.5)

end subroutine write_cube

subroutine write_cube_double(s,iunit)
type(cube), intent(in)        :: s
integer, intent(in)           :: iunit
integer                       :: i,j,k,kk,columns
character(LEN=10)             :: fmts

fmts="(   e17.9)"

!nx=size(rho(:,1,1))
!ny=size(rho(1,:,1))
!nz=size(rho(1,1,:))

columns=mod(s%nz,6)



write(iunit,*)"filecube"
write(iunit,*)"filecube"
write(iunit,36)s%natoms,s%offset
write(iunit,36)s%nx,s%dx(1,1:3)
write(iunit,36)s%ny,s%dx(2,1:3)
write(iunit,36)s%nz,s%dx(3,1:3)

do i=1,s%natoms
 write(iunit,37)s%dumn(i),s%dumr(i),s%pos(i,1:3)
enddo


select case(columns)

 case(0:0)

do i=1,s%nx
 do j=1,s%ny
  do k=1,s%nz,6
    write(iunit,44)(s%rho(i,j,k+kk),kk=0,5)
  enddo
 enddo
enddo

 case(1:5)

write(fmts(4:4),33)columns
do i=1,s%nx
 do j=1,s%ny
  do k=1,s%nz-6,6
  write(iunit,44)(s%rho(i,j,k+kk),kk=0,5)
  enddo
  write(iunit,fmts)(s%rho(i,j,s%nz-columns+kk),kk=1,columns)
 enddo
enddo

end select


33 format(i1)
36 format(i4,3f14.8)
37 format(i4,4f12.6)
44 format(6e17.9)
end subroutine write_cube_double


subroutine read_xyz(g,iunit)

type(geo), intent(inout)           :: g
integer, intent(in)                :: iunit
character(len=100)                  :: linea
integer                            :: i,sn

g%fmt="xyz"
read(iunit,*) g%n
allocate(g%p(g%n,3))
allocate(g%name(g%n))
read(iunit,33)linea
do i=1,g%n
  read(iunit,33)linea
  sn=first_char(linea)
  read(linea(sn+2:100),*) g%p(i,1:3)
  g%name(i)=linea(sn:sn+1)
enddo
g%b=0.d0
g%b(1,1)=70
g%b(2,2)=70
g%b(3,3)=70

33 format(a)

end subroutine read_xyz

subroutine write_xyz(g,iuni)

type(geo), intent(in)        :: g
integer, intent(in)          :: iuni
real*8, allocatable          :: pos(:,:)
integer                      :: i

select case(g%fmt)

case("xyz")

write(iuni,*)g%n
write(iuni,*)g%n
do i=1,g%n
 write(iuni,33)g%name(i),g%p(i,1:3)
enddo

case("xtl","xsd")
allocate(pos(g%n,3))
call aff2cart(g%p,pos,g%b)

write(iuni,*)g%n
write(iuni,*)g%n
do i=1,g%n
 write(iuni,33)g%name(i),pos(i,1:3)
enddo

deallocate(pos)

case default
print*,"wrong conversion"
stop

end select

33 format(a,3f20.12)


end subroutine write_xyz

subroutine read_col(v,nc,iunit)

real*8, intent(out)    :: v(:)
integer, intent(in)    :: nc,iunit
integer                :: i,nr,ncr,nel,iuni

nel=size(v(:))
nr=nel/nc
ncr = nel - nr * nc


do i=1,nr
 read(iunit,*)v((i-1)*nc+1:i*nc)
enddo

if(ncr.gt.0) then
 read(iunit,*)v(nel-ncr+1:nel)
endif

end subroutine read_col

subroutine read_dcd(pos,iunit)

real, intent(out)   :: pos(:,:,:)
integer, intent(in)   :: iunit

character(len=4)    :: hdr
character(len=80)   :: dumc1,dumc2
integer              :: i,dumi,nat,nframes
real*8            :: cell(6)
real              :: dt


 nframes=size(pos(:,1,1)) 
!print*,nframes
!write(6,*)nframes

 read(iunit) hdr,dumi,dumi,dumi,dumi,dumi,dumi, &
             dumi,dumi,dumi,dt,dumi,dumi,dumi ,&
             dumi,dumi,dumi,dumi,dumi,dumi,dumi
!write(6,*)dumi,hdr
 read(iunit) dumi,dumc1,dumc2
 read(iunit) nat
!print*,nat 
!write(6,*)dumc1
!write(6,*)dumc2
!write(6,*)nat
!write(6,*)dumi,dt
do i=1,nframes
read(iunit)cell
read(iunit)pos(i,1:nat,1)
read(iunit)pos(i,1:nat,2)
read(iunit)pos(i,1:nat,3)
enddo
 

end subroutine read_dcd

subroutine write_xtl(g,iuni)
type(geo),intent(in)            :: g
integer, intent(in)             :: iuni
integer                         :: i
real*8, allocatable             :: pa(:,:)   

select case(g%fmt)
case("xyz")

 allocate(pa(g%n,3))

 write(iuni,33)"TITLE"
 write(iuni,33)"CELL"
 write(iuni,*)norm(g%b(1,1:3)),norm(g%b(2,1:3)),norm(g%b(3,1:3)),&
 ang(g%b(2,1:3),g%b(3,1:3)),ang(g%b(1,1:3),g%b(3,1:3)),ang(g%b(1,1:3),g%b(2,1:3))
 write(iuni,33)"SYMMETRY  NUMBER 1  LABEL P1"
 write(iuni,33)"SYM MAT  1.0  0.0  0.0  0.0  1.0  0.0  0.0  0.0  1.0 0.0000 0.0000 0.0000"
 write(iuni,33)"ATOMS"
 write(iuni,33)"NAME           X             Y             Z"
 call cart2aff(g%p,pa,g%b)
 do i=1,g%n
  write(iuni,34)g%name(i),pa(i,1:3)
 enddo

 deallocate(pa)

case("xsd","xtl")
 write(iuni,33)"TITLE"
 write(iuni,33)"CELL"
 write(iuni,*)norm(g%b(1,1:3)),norm(g%b(2,1:3)),norm(g%b(3,1:3)),&
 ang(g%b(2,1:3),g%b(3,1:3)),ang(g%b(1,1:3),g%b(3,1:3)),ang(g%b(1,1:3),g%b(2,1:3))
 write(iuni,33)"SYMMETRY  NUMBER 1  LABEL P1"
 write(iuni,33)"SYM MAT  1.0  0.0  0.0  0.0  1.0  0.0  0.0  0.0  1.0 0.0000 0.0000 0.0000"
 write(iuni,33)"ATOMS"
 write(iuni,33)"NAME           X             Y             Z"
 do i=1,g%n
  write(iuni,34)g%name(i),g%p(i,1:3)
 enddo
case default
 print*,"wrong conversion"
 stop
end select

33 format(a)
34 format(a2,1x,3f12.6)

end subroutine write_xtl

subroutine read_xsd(g,iuni)

type(geo),intent(out)              :: g
integer, intent(in)                :: iuni
character(LEN=600)                 :: line
character(LEN=6)                   :: s6
character(LEN=7)                   :: s7
character(LEN=10)                  :: s10
character(LEN=3)                   :: s3
character(LEN=2)                   :: name(30000)
real                               :: pos(30000,3)
integer                            :: n,p,il,i
logical                            :: finefile,found_cell,l1,l2

n=0
s3="XYZ"
s6="Atom3d"
s7="AVector"
s10="Components"
finefile=.false.
found_cell=.false.

do while(.not.finefile)

 line=""
 read(iuni,33,END=37)line
 if(thereis(line,s7)) then
  p=whereis(line,s7)
  found_cell=.true.
  do il=p,p+210
   if(ichar(line(il:il)).gt.57.or.ichar(line(il:il)).lt.45) then
     l1=line(il:il).eq."e".or.line(il:il).eq."E"
     l2=48.le.ichar(line(il-1:il-1)).and.57.ge.ichar(line(il-1:il-1))
     if(.not.(l1.and.l2)) line(il:il)=" "
   endif
  enddo
  read(line(p:p+210),*)g%b(1,1:3),g%b(2,1:3),g%b(3,1:3)
 else
  if(thereis(line,s10).and.thereis(line,s6).and.thereis(line,s3)) then
  n=n+1 
  p=whereis(line,s10)
  name(n)=line(p+12:p+13)
  if(name(n)(2:2).eq.char(34))name(n)(2:2)=" "
  p=whereis(line,s3)
  do il=p,p+75
   if(ichar(line(il:il)).gt.57.or.ichar(line(il:il)).lt.45) then
     l1=line(il:il).eq."e".or.line(il:il).eq."E"
     l2=48.le.ichar(line(il-1:il-1)).and.57.ge.ichar(line(il-1:il-1))
     if(.not.(l1.and.l2)) line(il:il)=" "
   endif
  enddo
  read(line(p:p+75),*)pos(n,1:3)

  endif
 endif

enddo
37 continue

 g%n=n
 allocate(g%p(n,3))
 allocate(g%name(n))
 do i=1,n
  g%p(i,1:3)=pos(i,1:3)
  g%name(i)=name(i)
 enddo
 if(found_cell) then
  g%fmt="xsd"
 else
  g%fmt="xyz"
  g%b=0.d0
  g%b(1,1)=10.d0
  g%b(2,2)=10.d0
  g%b(3,3)=10.d0
 endif

33 format(a600)

end subroutine read_xsd

subroutine read_xtl(g,iuni)

type(geo),intent(out)            :: g
character(LEN=4)    :: tag
character(LEN=80),allocatable    :: line(:)
character(LEN=80),allocatable    :: lineb(:)
integer,intent(in)               :: iuni
integer                          :: buf,nlines,i,sn
real*8                           :: celldm(6)

g%fmt="xtl"
buf=50

tag="    "
do while(tag(1:4).ne."CELL")
 read(iuni,33)tag
enddo

read(iuni,*) celldm(1:6)

do while(tag(1:4).ne."NAME")
 read(iuni,33)tag
enddo

allocate(line(buf))

nlines=0
do while(tag(1:3).ne."EOF")
 nlines=nlines+1
 read(iuni,33,END=37)line(nlines)
 if (mod(nlines,buf)==0)then
   allocate(lineb(nlines))
   lineb=line
   deallocate(line)
   allocate(line(nlines+buf))
   line(1:nlines)=lineb
   deallocate(lineb)
 endif
 tag=line(nlines)(1:4)
enddo

nlines=nlines-1

allocate(g%p(nlines,3))
allocate(g%name(nlines))
g%n=nlines

do i=1,nlines
  sn=first_char(line(i))
  read(line(i)(sn+2:80),*) g%p(i,1:3)
  g%name(i)=line(i)(sn:sn+1)
enddo 

call celldm2basis(celldm,g%b)


33 format(a)
37 continue

end subroutine read_xtl

subroutine read_geo(g,f,iunit)

type(geo), intent(inout)     :: g
character(LEN=*), intent(in) :: f
integer, intent(in)          :: iunit
integer                      :: l
character(len=3)             :: fmt
type(cube)                   :: c
real, allocatable            :: pos(:,:)

call init_periodic_table()

l=strlen(f)
g%fmt=f(l-2:l)
fmt=g%fmt

select case(fmt)
 case ("xyz")
  open(unit=iunit,file=f,status="unknown")
  g%fmt="xyz"
  call read_xyz(g,iunit)
  close(unit=iunit)
 case ("xtl")
  g%fmt="xtl"
  open(unit=iunit,file=f,status="unknown")
  call read_xtl(g,iunit)
  close(unit=iunit)
! case ("dcd")
!  open(unit=iunit,file=f,status="unknown",form="unformatted")
!  call read_dcd(pos,iunit)
!  
!  close(unit=iunit)
 case ("ube")
  g%fmt="xyz"
  open(unit=iunit,file=f,status="unknown")
  call read_cube(c,iunit)
  call cube2geo(c,g)
  close(unit=iunit)
  call free_cube(c)
 case default
 print*,"unknown format ",g%fmt
 stop
end select


end subroutine read_geo


end module io
