program ruotamols

use io
implicit none

type(geo)              :: g
integer                :: nmols
integer                :: iunit,nrot,id,i,j,k,maxin
integer, allocatable   :: mols(:,:),size_mols(:)
real*8                 :: bd,a,axis(3),pcm(3)
real*8, allocatable    :: pos(:,:)
logical, allocatable   :: assigned(:),assignedold(:),followed(:)
character(len=30)      :: fi,fo
!!!!!!TEST
real*8 :: d(12)
integer  :: nv,v(12)
!!!!!!!!!


print*, "nome file in"
read(*,33) fi
print*, "nome file out"
read(*,33) fo
print*,"max index"
read*, maxin

iunit=7

call read_geo(g,fi,iunit)


allocate(mols(g%n-1,g%n-1))
allocate(size_mols(g%n-1))
allocate(assigned(g%n))
allocate(assignedold(g%n))
allocate(followed(g%n))
assigned=.false.
size_mols=0
nmols=0
followed=.false.

!!!!!!!TEST
!print*,g%n
!print*,g%n,g%b(1,1)
!i=5
!j=1
!call neighbors(g,i,nv,v,d)
!write(6,*)nv,v(1:nv)
!write(6,*)nv,d(1:nv)
!print*,connected(g,followed,i,j)
!stop
!!!!!!!END

assigned=.false.
do i=1,min(g%n,maxin)
 assignedold=assigned
 if(.not.assigned(i)) then
  nmols=nmols+1
  assigned(i)=.true.
  size_mols(nmols)=size_mols(nmols)+1 
  mols(nmols,size_mols(nmols))=i
  do j=i+1,min(g%n,maxin)
   if(.not.assigned(j)) then
     followed=assignedold
     if(connected(g,followed,i,j) ) then
      assigned(j)=.true. 
      size_mols(nmols)=size_mols(nmols)+1 
      mols(nmols,size_mols(nmols))=j
      do k=j+1,min(maxin,g%n)                  !!FAST
       if(followed(k).and.(.not.assigned(k))) then                    !!FAST 
        assigned(k)=.true.                     !!FAST
        size_mols(nmols)=size_mols(nmols)+1    !!FAST
        mols(nmols,size_mols(nmols))=k         !!FAST
       endif                                   !!FAST
      enddo
     endif
   endif
  enddo
 endif
enddo


print*,"found nmols= ",nmols

do i=1,nmols
 if(size_mols(i).gt.1)then
  print*,"mol, natoms",i,size_mols(i),mols(i,1:size_mols(i))
 endif
enddo

print*,"how many rotations? "
read*,nrot


do i=1,nrot
 print*,"idmol, angle, axis"
 read*,id,a,axis
 allocate(pos(size_mols(id),3))
 do j=1,size_mols(id) 
  pos(j,1:3)=g%p(mols(id,j),1:3) 
 enddo
 pcm(1)=sum(pos(1:size_mols(id),1))/size_mols(id)
 pcm(2)=sum(pos(1:size_mols(id),2))/size_mols(id)
 pcm(3)=sum(pos(1:size_mols(id),3))/size_mols(id)
 call ruota(axis,pcm,a,pos)
 do j=1,size_mols(id)
  g%p(mols(id,j),1:3)=pos(j,1:3)
 enddo
 deallocate(pos)
enddo

open(unit=iunit,file=fo,status="unknown")
call write_xyz(g,iunit)
close(unit=iunit)

deallocate(mols)
call destroy_geo(g)

33 format(a)

end
