module tricks

 implicit none

interface assignment(=)
 module procedure streqnum
end interface

 contains

logical function thereis(s1,s2)
character(len=*), intent(in)      :: s1,s2
integer                           :: l1,l2,i
l1=len(s1)
l2=len(s2)

thereis=.false.
do i=1,l1-l2-1
 if(s1(i:i+l2-1).eq.s2) then
  thereis=.true.
  goto 33
 endif
enddo

33 continue

end function thereis

subroutine intervals(nx,numprocs,io,i,f)

integer, intent(in)      :: nx,numprocs,io
integer, intent(out)     :: i,f
integer                  :: ires,nperproc


ires=mod(nx,numprocs)
nperproc=nx/numprocs

i=io*nperproc + 1 +ires
f=(io+1)*nperproc +ires

if(io.lt.ires) then
 i=io*(nperproc+1)+1
 f=(io+1)*(nperproc+1)
endif


end subroutine intervals

integer function whereis(s1,s2)
character(len=*), intent(in)      :: s1,s2
integer                           :: l1,l2,i
l1=len(s1)
l2=len(s2)

whereis=0
do i=1,l1-l2-1
 if(s1(i:i+l2-1).eq.s2) then
  whereis=i
  goto 33
 endif
enddo

33 continue

end function whereis

integer function first_char(a)
 character(LEN=*), intent(in)   :: a
 integer                        :: i
 do i=1,len(a)
  if(a(i:i).ne." ") goto 10
 enddo 
10 continue
first_char=i
end function first_char

integer function strlen(a)
 character(LEN=*), intent(in)   :: a
 integer                        :: i
 strlen=0
 i=1
 do while((a(i:i).ne."").and.(i.le.len(a))) 
  i=i+1
 enddo
 strlen=i-1
 return
end function strlen

 subroutine streqnum(a,b)

 character(LEN=*), intent(inout)  :: a
 integer, intent(in)              :: b

 select case(b)
   case(1:9)
     write(a,33)b
   case(10:99)
     write(a,34)b
   case(100:999)
     write(a,35)b
   case(1000:9999)
     write(a,36)b
 end select

33 format(i1)
34 format(i2)
35 format(i3)
36 format(i4)

 return

 end subroutine streqnum

integer function ndigits(n)

integer, intent(in)   ::n

!ndigits=nint(dlog(n*1.d0)/dlog(10.d0)+1)
select case(n)
case(1:9)
ndigits=1
case(10:99)
ndigits=2
case(100:999)
ndigits=3
case(1000:9999)
ndigits=4
case(10000:99999)
ndigits=5
case(100000:999999)
ndigits=6
case(1000000:9999999)
ndigits=7
case(10000000:99999999)
ndigits=8
end select

return

end function ndigits

end module tricks
